import React from 'react';
import PropTypes from 'prop-types';
import { Attributes } from './types';
export interface ElementProps {
    attributes?: Attributes;
    children?: React.ReactNode;
    selfClose?: boolean;
    tagName: string;
}
export default class Element extends React.PureComponent<ElementProps> {
    static propTypes: {
        attributes: PropTypes.Requireable<any>;
        children: PropTypes.Requireable<any>;
        selfClose: PropTypes.Requireable<any>;
        tagName: PropTypes.Validator<any>;
    };
    static defaultProps: {
        attributes: {};
        children: null;
        selfClose: boolean;
    };
    render(): JSX.Element;
}
