import React from 'react';
import PropTypes from 'prop-types';
import { MarkupProps } from './Markup';
import { FilterInterface } from './Filter';
import { MatcherInterface } from './Matcher';
import { AfterParseCallback, BeforeParseCallback, TransformCallback } from './types';
export interface InterweaveProps extends MarkupProps {
    disableFilters?: boolean;
    disableMatchers?: boolean;
    filters?: FilterInterface[];
    matchers?: MatcherInterface[];
    onAfterParse?: AfterParseCallback | null;
    onBeforeParse?: BeforeParseCallback | null;
    transform?: TransformCallback | null;
}
export default class Interweave extends React.PureComponent<InterweaveProps> {
    static propTypes: {
        content: PropTypes.Requireable<any>;
        disableFilters: PropTypes.Requireable<any>;
        disableLineBreaks: PropTypes.Requireable<any>;
        disableMatchers: PropTypes.Requireable<any>;
        disableWhitelist: PropTypes.Requireable<any>;
        emptyContent: PropTypes.Requireable<any>;
        filters: PropTypes.Requireable<any>;
        matchers: PropTypes.Requireable<any>;
        noHtml: PropTypes.Requireable<any>;
        noHtmlExceptMatchers: PropTypes.Requireable<any>;
        onAfterParse: PropTypes.Requireable<any>;
        onBeforeParse: PropTypes.Requireable<any>;
        tagName: PropTypes.Requireable<any>;
        transform: PropTypes.Requireable<any>;
    };
    static defaultProps: {
        content: string;
        disableFilters: boolean;
        disableLineBreaks: boolean;
        disableMatchers: boolean;
        disableWhitelist: boolean;
        emptyContent: null;
        filters: never[];
        matchers: never[];
        noHtml: boolean;
        noHtmlExceptMatchers: boolean;
        onAfterParse: null;
        onBeforeParse: null;
        tagName: string;
        transform: null;
    };
    parseMarkup(): React.ReactNode | React.ReactNode[];
    render(): JSX.Element;
}
