import React from 'react';
import PropTypes from 'prop-types';
export interface MarkupProps {
    content?: string;
    disableLineBreaks?: boolean;
    disableWhitelist?: boolean;
    emptyContent?: React.ReactNode;
    noHtml?: boolean;
    noHtmlExceptMatchers?: boolean;
    parsedContent?: React.ReactNode;
    tagName?: string;
}
export default class Markup extends React.PureComponent<MarkupProps> {
    static propTypes: {
        content: PropTypes.Requireable<any>;
        disableLineBreaks: PropTypes.Requireable<any>;
        disableWhitelist: PropTypes.Requireable<any>;
        emptyContent: PropTypes.Requireable<any>;
        noHtml: PropTypes.Requireable<any>;
        noHtmlExceptMatchers: PropTypes.Requireable<any>;
        parsedContent: PropTypes.Requireable<any>;
        tagName: PropTypes.Requireable<any>;
    };
    static defaultProps: {
        content: string;
        disableLineBreaks: boolean;
        disableWhitelist: boolean;
        emptyContent: null;
        noHtml: boolean;
        noHtmlExceptMatchers: boolean;
        parsedContent: null;
        tagName: string;
    };
    getContent(): React.ReactNode;
    render(): JSX.Element;
}
