import React from 'react';
import { MatchCallback, MatchResponse, Props } from './types';
export declare type MatcherFactory = (match: string, props: Props) => React.ReactNode;
export interface MatcherInterface {
    inverseName: string;
    propName: string;
    asTag(): string;
    createElement(match: string, props?: Props): React.ReactNode;
    match(value: string): MatchResponse | null;
    onBeforeParse(content: string, props: Props): string;
    onAfterParse(content: React.ReactNode[], props: Props): React.ReactNode[];
}
export default class Matcher<T extends {} = {}> implements MatcherInterface {
    options: T;
    propName: string;
    inverseName: string;
    factory: MatcherFactory | null;
    constructor(name: string, options?: Partial<T>, factory?: MatcherFactory | null);
    createElement(match: string, props?: Props): React.ReactNode;
    replaceWith(match: string, props?: Props): React.ReactNode;
    asTag(): string;
    match(string: string): MatchResponse | null;
    doMatch(string: string, pattern: string | RegExp, callback: MatchCallback): MatchResponse | null;
    onBeforeParse(content: string, props: Props): string;
    onAfterParse(content: React.ReactNode[], props: Props): React.ReactNode[];
}
