import React from 'react';
import { FilterInterface } from './Filter';
import { MatcherInterface } from './Matcher';
import { Attributes, NodeConfig, TransformCallback } from './types';
export interface ParserProps {
    disableLineBreaks?: boolean;
    noHtml?: boolean;
    noHtmlExceptMatchers?: boolean;
    transform?: TransformCallback;
    [key: string]: any;
}
export default class Parser {
    doc: Document;
    content: React.ReactNode[];
    props: ParserProps;
    matchers: MatcherInterface[];
    filters: FilterInterface[];
    keyIndex: number;
    constructor(markup: string, props?: ParserProps, matchers?: MatcherInterface[], filters?: FilterInterface[]);
    applyAttributeFilters(name: string, value: string): string;
    applyNodeFilters(name: string, node: HTMLElement): HTMLElement;
    applyMatchers(string: string, parentConfig: NodeConfig): string | React.ReactNode[];
    canRenderChild(parentConfig: NodeConfig, childConfig: NodeConfig): boolean;
    convertLineBreaks(markup: string): string;
    createDocument(markup: string): Document;
    extractAttributes(node: HTMLElement): Attributes | null;
    getTagConfig(tagName: string): NodeConfig;
    isSafe(node: HTMLElement): boolean;
    parse(): React.ReactNode[];
    parseNode(parentNode: HTMLElement, parentConfig: NodeConfig): React.ReactNode[];
}
